#!/usr/bin/perl -w
#Author: liangf
my $version=1.00;

use strict;
use Getopt::Long;
use Time::localtime;


my %opts;
GetOptions(\%opts,"i=s","t=s","r=s","o=s","h");
if (!(defined $opts{i} and defined $opts{t} and defined $opts{r} and defined $opts{o} ) or defined $opts{h}) {
&usage;
}

my $in = $opts{'i'};
my $t = $opts{'t'};
my $ref = $opts{'r'};
my $out = $opts{'o'};


sub usage{
print <<"USAGE";
Version $version
Usage:
$0 -i -t -r -o
options:
-i input watson pile file
-t input "watson" or "crick", no other options
-r raw reference directory
-o output file
-h help
USAGE
exit(1);
}


=pod
=head
chr10   181138  A       1       ^~.     g
chr10   181139  C       1       T       g
chr10   181140  G       1       .       g
chr10   181141  C       1       T       g
chr10   181142  G       1       .       g
chr10   181143  A       1       .       g
chr10   181144  G       1       .       g
chr10   181145  T       1       .       g
chr10   181146  A       1       .       g
chr10   181147  A       1       .       g
=cut

my ($aa, @arr, $bb, @brr, $chr, $temp, $t1, $t2, $t3, $nbase, @base, @brr0, $type, $skip, $mc);

#################################################################################################
#
goto L if $t !~ /watson/i;

$nbase = 0;
$t2 = "N";
$t3 = "N";

open IN, "< $in";
$aa = <IN>;
chomp $aa;
@arr = split(/\s+/, $aa);
$chr = $arr[0];
close IN;

open IN, "< $in";
open INref, "< $ref/$chr.fa";
open OUT, "> $out";
print OUT "#Chromosome\t0-basedCoordinate\t1-basedCoordinate\tStrand\tSequenceContextType\tDepth\tmC_Depth\tMethylationLevel\n";

$bb = <INref>; 
chomp $bb;
$bb = <INref>; 
chomp $bb;
@brr = split(//, $bb);


while ($aa = <IN>) {
	chomp $aa;
	@arr = split(/\s+/, $aa);
	
	next unless $arr[2] =~ /^[Cc]$/ and $arr[3] > 0;
	$arr[4] =~ s/\^.//;
	$skip = 0;
	$mc = 0;
	
	@base = split //, $arr[4];
	
	for (my $i = 0; $i <= $#base; $i++) {
		if ($base[$i] eq "<" or $base[$i] eq ">") {#modify from if ($base[$i] eq "<") { on 20160313
			$skip ++;
		} elsif ($base[$i] eq "." or $base[$i] eq ",") {
			$mc++;
		}
	}
	
	die "$aa\nwhy???\t$arr[3]-$skip < $mc\n" if $arr[3]-$skip < $mc;
	
	$temp = $arr[1] + 2;
	until ($temp <= $nbase + $#brr + 1 or eof(INref)){
		$nbase += $#brr + 1;
		$bb = <INref>; 
		chomp $bb;
		@brr0 = @brr;
		@brr = split(//, $bb);
	}
	
	$t3 = $brr[$temp - $nbase - 1];
	
	if ($temp - 1 - $nbase - 1 >= 0) {
		$t2 = $brr[$temp - 1 - $nbase - 1];
	}else{
		$t2 = $brr0[$#brr0];
	}
	
	if ($temp - 2 - $nbase - 1 >= 0) {
		$t1 = $brr[$temp - 2 - $nbase - 1];
	}elsif($temp - 2 - $nbase - 1 == -1){
		$t1 = $brr0[$#brr0];
	}else{
		$t1 = $brr0[$#brr0-1];
	}
	
	die "reference is $t1 at @arr[0..2]\n@brr\n@brr0\n$t1\t$t2\t$t3\t$temp\t$nbase\n" if $t1 !~ /C/i;
	
	$type = watson_mC_type ($t2, $t3);
	
	print OUT join("\t", $chr, $arr[1] -1, $arr[1], "\+", $type, $arr[3]-$skip, $mc, $mc/($arr[3]-$skip)), "\n" unless $type eq "na" or $arr[3]-$skip == 0;
}


close INref;
close IN;
close OUT;
exit (0);
###################################################################################
#

L:

$nbase = 0;
$t2 = "N";
$t3 = "N";

open IN, "< $in";
$aa = <IN>;
chomp $aa;
@arr = split(/\s+/, $aa);
$chr = $arr[0];
close IN;

open IN, "< $in";
open INref, "< $ref/$chr.fa";
open OUT, "> $out";
print OUT "#Chromosome\t0-basedCoordinate\t1-basedCoordinate\tStrand\tSequenceContextType\tDepth\tmC_Depth\tMethylationLevel\n";

$bb = <INref>; 
chomp $bb;
$bb = <INref>; 
chomp $bb;
@brr = split(//, $bb);


while ($aa = <IN>) {
	chomp $aa;
	@arr = split(/\s+/, $aa);
	
	next unless $arr[2] =~ /^[Gg]$/ and $arr[3] > 0;
	$arr[4] =~ s/\^.//;
	$skip = 0;
	$mc = 0;
	
	@base = split //, $arr[4];
	
	for (my $i = 0; $i <= $#base; $i++) {
		if ($base[$i] eq ">" or $base[$i] eq "<") {#modify from if ($base[$i] eq ">") { on 20160313
			$skip ++;
		} elsif ($base[$i] eq "." or $base[$i] eq ",") {
			$mc++;
		}
	}
	
	die "$aa\nwhy???\t$skip + $mc > $arr[3]\n" if $skip + $mc > $arr[3];
	
	$temp = $arr[1];
	until ($temp <= $nbase + $#brr + 1 or eof(INref)){
		$nbase += $#brr + 1;
		$bb = <INref>; 
		chomp $bb;
		@brr0 = @brr;
		@brr = split(//, $bb);
	}
	
	$t1 = $brr[$temp - $nbase - 1];
	die "reference is $t1 at @arr[0..2]\n" if $t1 !~ /G/i;
	
	if ($temp - 1 - $nbase - 1 >= 0) {
		$t2 = $brr[$temp - 1 - $nbase - 1];
	}else{
		$t2 = $brr0[$#brr0];
	}
		
	if ($temp - 2 - $nbase - 1 >= 0) {
		$t3 = $brr[$temp - 2 - $nbase - 1];
	}elsif($temp - 2 - $nbase - 1 == -1){
		$t3 = $brr0[$#brr0];
	}else{
		$t3 = $brr0[$#brr0 - 1];
	}
	
	
	$type = crick_mC_type ($t2, $t3);
	
	print OUT join("\t", $chr, $arr[1] -1, $arr[1], "\-", $type, $arr[3]-$skip, $mc, $mc/($arr[3]-$skip)), "\n" unless $type eq "na" or $arr[3]-$skip == 0;
}


close INref;
close IN;
close OUT;

#*****************************************************************************************************

sub watson_mC_type{
	my @base = @_ ;
	
	if ($base[0] =~ /[Gg]/) {
		return "CG";
	} elsif ($base[0] =~ /[AaCcTt]/) {
		if ($base[1] =~ /[Gg]/) {
			return "CHG";
		} elsif ($base[1] =~ /[AaCcTt]/) {
			return "CHH";
		}
	}

	return "na";
}

sub crick_mC_type{
	my @base = @_ ;
	if ($base[0] =~ /[Cc]/) {
		return "CG";
	} elsif ($base[0] =~ /[AaGgTt]/) {
		if ($base[1] =~ /[Cc]/) {
			return "CHG";
		} elsif ($base[1] =~ /[AaGgTt]/) {
			return "CHH";
		}
	}

	return "na";
}